import greenfoot.*;
public class Shape extends Actor {
    private int x=300,y;
    private int angle=Greenfoot.getRandomNumber(159)+21;
    private int speedX=3,speedY=3;
    private int side=Greenfoot.getRandomNumber(2);
    private int counter=500;
    private Boolean drag=false,inCell=false;
    protected int type;
    public Shape() {
        if (side==0) {
            y=27;
            angle*=(Math.PI/180);
        } else {
            y=373;
            angle+=180;
            angle*=Math.PI;
            angle/=180;
        }
        setLocation(x,y);
    }
    public void act() {
        if (Greenfoot.mouseDragged(this)&&!inCell) {
            MouseInfo mouse=Greenfoot.getMouseInfo();
            x=mouse.getX();
            y=mouse.getY();
        } 
        if (Greenfoot.mousePressed(this)) drag=true;
        if (Greenfoot.mouseClicked(null)) {
            drag=false;
            setLocation((int)x,(int)y);
            if (x<153) {
                if (type==1||type==3) {
                    if (!inCell) {
                        Stage.leftCount++;
                        Stage.score++;
                        inCell=true;
                    }
                } else {
                    if (type==4) Stage.lives--;
                    removeMe();
                }
            } else if (x>446) {
                if (type==2||type==3) {
                    if (!inCell) {
                        Stage.rightCount++;
                        Stage.score++;
                        inCell=true;
                    }
                } else {
                    if (type==4) Stage.lives--;
                    removeMe();
                }
            }
        }
        if (inCell) {
            if (x>100&&x<300) x--;
            else if (x<500&&x>300) x++;
            if (counter<255) {
                counter=500;
                getImage().setTransparency(255);
            }
        } else {
            counter--;
            if (counter<=255) getImage().setTransparency(counter);
            if (counter==0) removeMe();
            if (!drag) {
                if (x<153) {
                    x=153;
                    speedX*=-1;
                } else if (x>446) {
                    x=446;
                    speedX*=-1;
                } else if (y<27) {
                    y=27;
                    speedY*=-1;
                } else if (y>373) {
                    y=373;
                    speedY*=-1;
                }
                x+=Math.cos(angle)*speedX;
                y+=Math.sin(angle)*speedY;
            }
        }
        setLocation(x,y);
    }
    private void removeMe() {
        if (type!=4) Stage.lives--;
        getWorld().removeObject(this);
    }
}